/* DESCRIPTION: */
/* 	DOOM graphics stuff for Atari Falcon/TT Xbios. */
/*  */

#include <stdio.h>

#include "i_system.h"
#include "atari.h"

int	cookie_mch=0;
int	cookie_vdo=0;
int	cookie_snd=0;
int	joypads=0;
int	atari_sound=0;

char *ataritxt_machine[4]={
	"Atari ST",
	"Atari STE/ST Book/Mega STE",
	"Atari TT",
	"Atari Falcon 030"
};

char *ataritxt_video[4]={
	"ST Shifter",
	"STE Shifter",
	"TT Shifter",
	"Falcon Videl"
};

char *ataritxt_sound[5]={
	"YM 2149",
	"8 bits DMA",
	"Xbios DMA functions",
	"16 bits CODEC",
	"DSP56001"
};

void I_ScanCookies(void)
{
	void *oldpile;
	unsigned long *cookie_jar;
	int i;

	/* Read cookie jar pointer */

	oldpile=(void *)Super(0);
	cookie_jar=_P_COOKIES;
	Super(oldpile);	

	printf("Reading hardware configuration...\n");

	/* Read cookies */

	while (*cookie_jar)
	{
		if (*cookie_jar==COOKIE_MCH)
			cookie_mch=*(cookie_jar+1);
		if (*cookie_jar==COOKIE_VDO)
			cookie_vdo=*(cookie_jar+1);
		if (*cookie_jar==COOKIE_SND)
			cookie_snd=*(cookie_jar+1);

		cookie_jar+=2;
	}

	/* Display cookies infos */

	printf(" Machine : ");
	cookie_mch >>= 16;
	if ((cookie_mch>=0) && (cookie_mch<4))
		printf("%s\n",ataritxt_machine[cookie_mch]);
	else
		printf("unknown\n");

	printf(" Video : ");
	cookie_vdo >>= 16;
	if ((cookie_vdo>=0) && (cookie_vdo<4))
		printf("%s\n",ataritxt_video[cookie_vdo]);
	else
		printf("unknown\n");

	printf(" Sound : ");
	for (i=0;i<5;i++)
		if (cookie_snd & (1<<i))
			printf("%s, ",ataritxt_sound[i]);
	printf("OK\n");

	/* Check available hardware */

	if (cookie_mch==MCH_F30)
		joypads=1;
/*	
	if ((cookie_vdo!=VDO_TT) && (cookie_vdo!=VDO_F30))
		I_Error("You need a TT or a Falcon\n");
*/
	if (cookie_snd & (1<<SND_DMA8))
		atari_sound=1;

	/* Display misc options */

	printf(" Joypads : ");
	if (joypads)
		printf("on\n");
	else
		printf("off\n");
}
